import 'package:flutter/cupertino.dart';
import 'package:osam/domain/state/base_state.dart';

// ignore: must_be_immutable
class NavigationState extends BaseState<NavigationState> {
  final List<String> routes;

  NavigationState({this.routes = const []});

  void push(String route) => routes.add(route);

  void pushReplacement(String route) =>
      routes.replaceRange(routes.length - 1, routes.length, [route]);

  void pushAndRemoveUntil(String route) => routes
    ..clear()
    ..add(route);

  void pop() => routes.removeLast();

  @override
  List<Object> get props => [routes];
}

// ignore: must_be_immutable
class TabNavigationState extends BaseState<TabNavigationState> {
  String currentTab;

  TabNavigationState({@required this.currentTab});

  void changeTab(String tab) => currentTab = tab;

  @override
  List<String> get props => [currentTab];
}
