import 'package:hive/hive.dart';
import 'package:path_provider/path_provider.dart';

class PersistRepository<T> {
  Box<T> _persist;

  Future<void> initPersist(String appName) async {
    Hive.init((await getApplicationDocumentsDirectory()).path);
    _persist ??= await Hive.openBox(appName);
  }

  void save(T object) => _persist.put('appState', object);

  T get() => _persist.get('appState');

  void delete() => _persist.delete('appState');

  void deleteFromDisk(String appName) => Hive.deleteBoxFromDisk(appName);

  void deleteHive() => Hive.deleteFromDisk();

  bool get isPersistEnabled => _persist == null ? false : true;
}
