import 'package:flutter_test/flutter_test.dart';
import 'package:osam/domain/event/event.dart';
import 'package:osam/domain/state/base_state.dart';
import 'package:osam/domain/store/store.dart';

// ignore: must_be_immutable
class AppState extends BaseState<AppState> {
  var count = 0;

  @override
  List<Object> get props => [count];
}

void main() {
  test('fits', () async {
    final store = Store(AppState());
    store.state.propertyStream((state) => state.count).listen((data) {
      print(data);
    });
    await Future.delayed(const Duration(seconds: 1), () {
      store.state.update();
    });
    await Future.delayed(const Duration(seconds: 2), () {
      store.state.update();
    });

    await Future.delayed(const Duration(seconds: 3), () {
      store.dispatchEvent(event: Event(reducer: (state) => state..count = 1));
    });
    await Future.delayed(const Duration(seconds: 5));
  });
}
